/*
 * dmabt.c -- Bluetooth Enabler for Toshiba Notebooks 
 *
 * Author: Martl <btenable@yahoo.de>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

// This peace of software requires a successful installation of Toshiba-Tools for Linux
// Which can be found here: http://www.buzzard.org.uk/toshiba/

#include <time.h>
#include <stdio.h>
#include <fcntl.h>
#include <sys/ioctl.h>

#define TOSH_PROC "/proc/toshiba"
#define TOSH_DEVICE "/dev/toshiba"
#define TOSH_SMM _IOWR('t',0x90,24)

typedef struct{
     unsigned int eax;
     unsigned int ebx __attribute__ ((packed));
     unsigned int ecx __attribute__ ((packed));
     unsigned int edx __attribute__ ((packed));
     unsigned int esi __attribute__ ((packed));
     unsigned int edi __attribute__ ((packed));
}SMMRegisters;

enum { HCI_GET = 0xfe00,
       HCI_SET = 0xff00,
       HCI_OWNERSTRING = 0x0029,
       HCI_FAILURE = 0x01,
       HCI_SUCCESS = 0x00};

int HciFunction(SMMRegisters *regs)
{int fd;
 if((fd=open(TOSH_DEVICE,O_RDWR))<0)
     return HCI_FAILURE;
 if(access(TOSH_PROC,R_OK)){
     close(fd);
     return HCI_FAILURE;}
 if(ioctl(fd,TOSH_SMM,regs)<0){
     close(fd);
     return HCI_FAILURE;}
 close(fd);
 return(int)(regs->eax & 0xff00)>>8;
}

main ()
{
   SMMRegisters reg;
   long i,a;
   time_t seconds1;
   time_t seconds2;
   int check=0;
printf("\n\n\n\nDMABTenable v.0.01.1");
printf("\n====================\n");
//Check if BT module is available 
        reg.eax = HCI_GET; //HCI_SET
        reg.edx = 0x0000; //0x0080
        reg.ebx = 0x0056; //0x0056
        reg.ecx = 0x0000; //0x0001
if (HciFunction(&reg)==0) 
   printf(" ");
else
  {printf("BT Available Key not supported!\n");     
    check=1;}
//Check if BT module is available 
if (!(reg.ecx & 0x0f) & check !=1)
   {printf("\n!!!!  No Bluetooth Module build in  !!!\n\n");
    check=1;}
//**********************************************************************
//Check if Wireless Switch is ON or OFF
        reg.eax = HCI_GET; //HCI_SET
        reg.edx = 0x0001; //0x0080
        reg.ebx = 0x0056; //0x0056
        reg.ecx = 0x0000; //0x0001
if (HciFunction(&reg)==0 & check !=1) 
  { //check if Wireless Switch is turned off or on
   if (!(reg.ecx & 0x1) & check !=1)
      {printf("\n!!!!  Wireless Switch is off  !!!\n\n");
       check=1;}
   else
   printf("\nBT Wireless Switch CHECK successful!\n");}
else
  {printf("\nBT Wireless Switch CHECK failure!\n");     
   check=1;}
//printf("\n Returnwert :  EAX:%x EBX:%x ECX:%x EDX:%x\n",reg.eax,reg.ebx,reg.ecx,reg.edx);
//**********************************************************************
if (check !=1)
{
//Power On BT Device
        reg.eax = HCI_SET; //HCI_SET
        reg.edx = 0x0080; //0x0080
        reg.ebx = 0x0056; //0x0056
        reg.ecx = 0x0001; //0x0001
if (HciFunction(&reg)==0 & check !=1) 
   printf("BT module powered on successful!\n");
else
  {printf("BT can't be powered on!\n");     
   check=1;}
if (check !=1)
{
//wait for 3s
seconds1=time(NULL);
seconds2=time(NULL);
while ((seconds2-seconds1) < 3)   //figure out how many seconds i.e. 3s
   seconds2=time(NULL);
        reg.eax = HCI_SET;
        reg.edx = 0x0040; //0xc800
        reg.ebx = 0x0056; //0x004d
        reg.ecx = 0x0001; //0x0101
if (HciFunction(&reg)==0 & check !=1) 
   printf("BT module attached successful!\n");
else
  {printf("BT module can't be attached!\n");     
   check=1;}
}}
if (check!=1)
   printf("\n!!! Your Bluetooth DEVICE is ready to use !!!\n\n");
else
  printf("\n!!!!!..Your Bluetooth DEVICE isn't ready.....!!!!!\n\n");
}



